Type TMenuItem
	
	Field label:String
	Field command:Int()
	
	
End Type

Type TPopMenu
		
	Field title:String
	Field list:TList = CreateList()
	Field hovered:Int = -1

	Function Create:TPopMenu(tit:String, items:TMenuItem[], n:Int)
		
		Local m:TPopMenu = New TPopMenu
		
		m.title = tit
		
		For Local l:TMenuItem = EachIn(items)
			
			m.list.AddLast(l)
			
		Next
		
		Return m
		
	End Function
	
	Method update()
		
		Local y:Int = 80, i:Int = 0
		For Local l:TMenuItem = EachIn(list)
			
			If(MouseX() >= 50 And MouseY() >= y And MouseX() < 290 And MouseY() < y + 50) Then
				hovered = i
				If click Then
					l.command()
					popmenu = Null
				EndIf
			EndIf
			
			y:+50
			i:+1
		Next
	
	End Method
	
	Method draw()
		SetColor 255, 255, 255
		DrawRect(20, 47, 240, 28)
		SetColor 255, 0, 0
		DrawText(title, 50, 50)
		Local y:Int = 80, i:Int = 0
		For Local l:TMenuItem = EachIn(list)
			
			SetColor 255, 0, 0
			DrawRect(50, y - 3, 240, 58)
			SetColor 255, 255, 255
			DrawText(" - " + l.label, 55, y)
			
			If(hovered = i) Then
				DrawText(" - " + l.label, 54, y)
				DrawText(" - " + l.label, 56, y)
				DrawText(" - " + l.label, 55, y + 1)
				DrawText(" - " + l.label, 55, y - 1)
			EndIf
			y:+50
			i:+1
		Next
	
	End Method
	
EndType

