Type TAlert
	
	Global str:String
	Global visible:Int = False
	
	Function show(s:String)
		str = s
		visible = True
		
		If sleeping Then
			TMessage.add_message("Woke up after " + sleep_duration + " hours of sleep")
			sleep_duration = 0
			sleeping = False
			set_panel_text(text_welcome)
		EndIf
		
	End Function
	Function hide()
		visible = False
	End Function
	
	Function draw()
		SetColor(0, 0, 0)
		DrawRect(160, 120, 320, 180)
		DrawRect(280, 370, 80, 40)
		SetColor(255, 0, 0)
		DrawText(str, 250, 180)
		
		
		
		DrawLine(160, 120, 160, 300)
		DrawLine(160, 300, 480, 300)
		DrawLine(480, 120, 480, 300)
		DrawLine(160, 120, 480, 120)
		
		DrawText("OK", 320, 390)
		DrawLine(320 - 40, 390 - 20, 320 - 40, 390 + 20)
		DrawLine(320 + 40, 390 - 20, 320 + 40, 390 + 20)
		DrawLine(320 - 40, 390 + 20, 320 + 40, 390 + 20)
		DrawLine(320 - 40, 390 - 20, 320 + 40, 390 - 20)
		SetColor(255, 255, 255)
		
		
		
	End Function
	
	
	
		
End Type

Type TMessage
	
	Global messages:TMessage[20]
	Global num_messages:Int
	
	
	Field message:String
	Field millisec:Int
	
	
	
	Function add_message(m:String)
		Local mes:TMessage = New TMessage
		
		
		mes.message = m
		mes.millisec = MilliSecs()
		
		
		
		
		If(num_messages = 19) Then
			For Local i:Int = num_messages Until 0 Step - 1
				messages[i] = messages[i - 1]
			Next
		Else
			For Local i:Int = num_messages Until 0 Step - 1
				messages[i] = messages[i - 1]
			Next
			num_messages:+1
		EndIf
		
		messages[0] = mes
		
	End Function
	
	Function handle_messages()
		Local clear:Int
		For Local i:Int = 0 Until num_messages
			If(MilliSecs() - messages[i].millisec > 7000) Then
				clear:+1
			EndIf
		Next
		num_messages:-clear
		
	End Function
	
	Function draw_messages()
		For Local i:Int = 0 Until num_messages
			SetColor(0, 0, 0)
			DrawText(messages[i].message, 10 + 1, 20 + 20 * i)
			DrawText(messages[i].message, 10 - 1, 20 + 20 * i)
			DrawText(messages[i].message, 10, 20 + 20 * i - 1)
			DrawText(messages[i].message, 10, 20 + 20 * i + 1)
		Next
		
		For Local i:Int = 0 Until num_messages
			SetColor(0, 255, 0)
			DrawText(messages[i].message, 10, 20 + 20 * i)
			
		Next
	End Function

End Type
