rem
	bbdoc: A room in the apartment
end rem
Type TRoom
	
	Global room_active:TRoom = Null
	

	Field coords:Float[]
	Field red:Int = 25
	Field green:Int = 30
	Field blue:Int = 40
	Field name:String
	
	Function Create:TRoom(ncoords:Float[], which:String)
		
		Local rm:TRoom = New TRoom
		
		rm.name = which
		
		Local n:Int = (ncoords.length)
		
		rm.coords = rm.coords[..n]
		For Local c:Int = 0 Until n
			rm.coords[c] = ncoords[c]
		Next
		
		Return rm
	
	End Function
	
	
	Method update(ox:Int, oy:Int, sc:Float)
		
		Local n:Int = coords.Length
		
		Local a:Float[n]
		For Local c:Int = 0 Until n
			If(c Mod 2 = 0)  then
				a[c] = (ox + coords[c]) * sc
			Else
				a[c] = (oy + coords[c]) * sc
			EndIf
		Next
		
	
	
		If(pointInPolygon(a, MouseX(), MouseY())) Then
			red = 55
			hint = name
			If(click And available) Then
				pick
			EndIf
		Else
			red = 25
		EndIf
			
			
		
	End Method
	
	Method pick()
		If(Self = rm_bathroom) Then
			TMessage.add_message ("This is not the Sims...")
			Return
		EndIf
		If(room_active <> Null) room_active.green = 30
		green = 55
		changed_room = (room_active <> Self)
		room_active = Self
		
	End Method
	
	
	Method draw(ox:Int, oy:Int, sc:Float)
		SetColor red, green, blue
		
		Local n:Int = coords.Length
		
		Local a:Float[n]
		For Local c:Int = 0 Until n
			If(c Mod 2 = 0)  then
				a[c] = (ox + coords[c]) * sc
			Else
				a[c] = (oy + coords[c]) * sc
			EndIf
		Next
		DrawPoly(a)
		
		
		
		SetColor 120, 205, 255
		
		For Local c:Int = 0 Until n Step 2
			
			Local x1:Float = coords[c + 0]
			Local y1:Float = coords[c + 1]
			Local x2:Float = coords[(c + 2) Mod n]
			Local y2:Float = coords[(c + 3) Mod n]
		
			DrawLine((ox + x1) * sc, (oy + y1) * sc, (ox + x2) * sc, (oy + y2) * sc)
			rem
			Local x3:Float = 320.0 + ((ox + x1) - 320.0) * 1.4
			Local y3:Float = 240.0 + ((oy + y1) - 240.0) * 1.4
			Local x4:Float = 320.0 + ((ox + x2) - 320.0) * 1.4
			Local y4:Float = 240.0 + ((oy + y2) - 240.0) * 1.4
						
			' Draw away from center
			DrawLine((ox + x1) * sc, (oy + y1) * sc, (ox + x3) * sc, (oy + y3) * sc)
			DrawLine((ox + x3) * sc, (oy + y3) * sc, (ox + x4) * sc, (oy + y4) * sc)
			endrem
		Next
		
		
	End Method
	
End Type


