rem
	bbdoc: Stuff inside rooms
end rem
Type TItem
	
	Field x:Float, y:Float
	Field gfx:TImage
	Field label:String
	Field clicklabel:String
	Field clicktime:Int
	Field active:Int
	Field enabled:Int
	Field room:TRoom
	Field action:Int()
	
	
	Function Create:TItem(nx:Float, ny:Float, g:TImage, lab:String, rm:TRoom)
		
		Local it:TItem = New TItem
		it.x = nx
		it.y = ny
		it.room = rm
		it.gfx = g
		it.label = lab
		it.clicklabel = "This doesn't have a click event handler"
		it.clicktime = MilliSecs()
		it.active = False
		it.enabled = True
		
		it.action = defaultItemBehaviour
		
		Return it
	
	End Function
	
	Method update(ox:Int, oy:Int, sc:Float)
		
		ResetCollisions()
		CollideImage(cursor, mx, my, 0, 0, 1)
		
		SetTransform(0, sc * 0.5, sc * 0.5)
	
		If(CollideImage(gfx, (ox + x) * sc, (oy + y) * sc, 0, 1, 0)) Then
			hint = label
			
			If(click) Then
				
				If(sleeping) Then
					zzz()
				Else
					action()
					clicktime = MilliSecs()
				EndIf
			EndIf
		EndIf
		
		
		
		SetTransform(0, 1, 1)
		
	End Method
	
	
	Method draw(ox:Int, oy:Int, sc:Float)
	
		SetColor 255, 255, 255
		SetTransform(0, sc * 0.5, sc * 0.5)
		DrawImage(gfx, (ox + x) * sc, (oy + y) * sc, active)
		SetTransform(0, 1, 1)
		
	End Method
	
End Type


Function defaultItemBehaviour()
	TMessage.add_message("This doesn't have a click event handler")
End Function
